* Program file of the project "Outsourcing and Firm Productivity" - 1A_IABdata99.do
* Contents: Keep necessary variables from the 1999 year
*            These variables will be used as lags for instrument variables on the year 2000 

* Level of Aggregation:  Firm level IAB data
* Need to deflate Deutsche Mark to Euros.  See http://www.ecb.int/press/pr/date/1998/html/pr981231_2.en.html for conversion rate

clear 
set mem 600m

capture log close
log using log/1A_IABdata99.log, replace


# delimit ;

use orig/test1999.dta, clear;

** Collect relevant variables from the 1999 IAB panel ;
** Rename variables ;

keep idnum g87b g27fach g27unge g26 ;

* Change all values to missing, if coded with an -8 or -9 (before data transformations for output, int_investment;
mvdecode _all, mv(-9 -8) ;

* g87b is current industry classification ;

* Total Skilled Employees ;
rename g27fach skill_emp99 ;
label var skill_emp99 "Total Skilled Employees 1999" ; 

* Total Non Skilled Employees ;
rename g27unge nonskill_emp99 ;
label var nonskill_emp99 "Total Non Skilled Employees 1999" ; 

* Quality of capital ;
rename g26 qualcap99 ;
label var qualcap99 "Quality of Capital 1999" ;


* Change all values to missing, if coded with an -8 or -9 ;
mvdecode _all, mv(-9 -8) ;

save data/1A_IABdata99.dta, replace ;

sort idnum;  
log close ;


