* Program file of the project "Outsourcing and Firm Productivity" - 1B_IABdata95.do
* Contents: Keep necessary variables from the 1999 year
*            These variables will be used as lags for instrument variables on the year 2000 

* Level of Aggregation:  Firm level IAB data
* Need to deflate Deutsche Mark to Euros.  See http://www.ecb.int/press/pr/date/1998/html/pr981231_2.en.html for conversion rate

clear 
set mem 600m

capture log close
log using log/1B_IABdata95.log, replace


# delimit ;

use orig/test1995.dta, clear;

** Collect relevant variables from the 1995 IAB panel ;
** Rename variables ;

keep idnum cz07b c39fach c39unge c24 ;

* Change all values to missing, if coded with an -8 or -9 (before data transformations for output, int_investment;
mvdecode _all, mv(-9 -8) ;

* cz07b is current industry classification ;

* Total Skilled Employees ;
rename c39fach skill_emp95 ;
label var skill_emp95 "Total Skilled Employees 1995" ; 

* Total Non Skilled Employees ;
rename c39unge nonskill_emp95 ;
label var nonskill_emp95 "Total Non Skilled Employees 1995" ; 

* Quality of capital ;
rename c24 qualcap95 ;
label var qualcap95 "Quality of Capital 1995" ;


* Change all values to missing, if coded with an -8 or -9 ;
mvdecode _all, mv(-9 -8) ;

save data/1B_IABdata95.dta, replace ;

sort idnum;  
log close ;


