* Program file of the project "Outsourcing and Firm Productivity" - 1C_IABdata96.do
* Contents: Keep necessary variables from the 1996 data set, for analysis on the 1995 year
*            These variables will be used as lags for the year 2000 data in Instrument Variable analysi

* Level of Aggregation:  Firm level IAB data
* NOTE: Need to deflate Deutsche Mark to Euros.  See http://www.ecb.int/press/pr/date/1998/html/pr981231_2.en.html for conversion rate

clear 
set mem 600m

capture log close
log using log/1C_IABdata96.log, replace


# delimit ;

use orig/test1996.dta, clear;

** Collect relevant variables from the 1996 IAB panel ;
** Rename variables ;

keep idnum d81b d12 d01ges95;

* Change all values to missing, if coded with an -8 or -9 (before data transformations for output, int_investment;
mvdecode _all, mv(-9 -8) ;

* d81b is current industry classification ;

* 1995 output in DM ;
generate output95 = d12 / 1955.83 ;
label var output95 "Sales in 1995, thousands of euros" ; 
drop d12 ;

* Total Employees ;
rename d01ges95 emp95 ;
label var emp95 "Total Employees 1995" ;

sort idnum;

save data/1C_IABdata96.dta, replace ; 
log close ;


