* Program file of the project "Outsourcing and Firm Productivity" - 3A_IABdata04.do
* Contents: Keep necessary variables from the 2004 year
*            These variables will be used as lags for instrument variables on the year 2005 

* Level of Aggregation:  Firm level IAB data
* Need to deflate Deutsche Mark to Euros.  See http://www.ecb.int/press/pr/date/1998/html/pr981231_2.en.html for conversion rate

clear 
set mem 600m

capture log close
log using log/3A_IABdata04.log, replace


# delimit ;

use orig/test2004.dta, clear;

** Collect relevant variables from the 2004 IAB panel ;
** Rename variables ;

keep idnum l30fach l30unge;

* Change all values to missing, if coded with an -8 or -9 (before data transformations for output, int_investment;
mvdecode _all, mv(-9 -8) ;

* Total Skilled Employees ;
rename l30fach skill_emp04 ;
label var skill_emp04 "Total Skilled Employees 2004" ; 

* Total Non Skilled Employees ;
rename l30unge nonskill_emp04 ;
label var nonskill_emp04 "Total Non Skilled Employees 2004" ; 

* Change all values to missing, if coded with an -8 or -9 ;
mvdecode _all, mv(-9 -8) ;

save data/3A_IABdata04.dta, replace ;

sort idnum;  
log close ;


