* Program file of the project "Outsourcing and Firm Productivity" - 3B_IABdata03.do
* Contents: Keep necessary variables from the 2003 year - Note: there is no measure of capital quality in 2004 (hence we'll use 2003)
*            These variables will be used as lags for instrument variables on the year 2005 

* Level of Aggregation:  Firm level IAB data
* Need to deflate Deutsche Mark to Euros.  See http://www.ecb.int/press/pr/date/1998/html/pr981231_2.en.html for conversion rate

clear 
set mem 600m

capture log close
log using log/3B_IABdata04.log, replace


# delimit ;

use orig/test2003.dta, clear;

** Collect relevant variables from the 2004 IAB panel ;
** Rename variables ;

keep idnum k22;

* Quality of capital ;
rename k22 qualcap03 ;
label var qualcap03 "Quality of Capital 2003" ;

* Change all values to missing, if coded with an -8 or -9 ;
mvdecode _all, mv(-9 -8) ;

save data/3B_IABdata03.dta, replace ;

sort idnum;  
log close ;


