* Program file of the project "Outsourcing and Firm Productivity" - 6_concordance2006.do
* Contents: Create variable 'class' for industry classification 
*           Use data from the 4_IABdata06 file - smaller data file to run faster


* Level of Aggregation:  Firm level IAB data

clear
set mem 600m

capture log close
log using log/6_concordance2006.log, replace

use data/4_IABdata06.dta, clear

#delimit ;

generate class = . ;
label var class "classification of industries" ;
label values class clabel ;

***********************************************;
**             CONCORDANCE                   **;
***********************************************;

replace class = 1 if n96b == 1 ;
label define clabel 1 "agriculture, hunting, forestry and fishing" ;

replace class = 2 if n96b == 2 ;
label define clabel 2 "mining and quarrying plus electricity gas water", modify ;

replace class = 3 if n96b == 7 ;
label define clabel 3 "Chemicals, coke, refined petroleum, nuclear fuel", modify ;

replace class = 4 if n96b == 8 ;
label define clabel 4 "Rubber and Plastic Products", modify ;

replace class = 5 if n96b == 9 ;
label define clabel 5 "Other non-metallic products", modify ;

replace class = 6 if n96b == 10 ;
label define clabel 6 "Manufacture of Basic Metals, fabricated metal products, ex machinery", modify ;

replace class = 6 if n96b == 12 ;
label define clabel 6 "Fabricated Metal products, ex machinery", modify ;

replace class = 8 if n96b == 13 ;
label define clabel 8 "Machinery", modify ;
 
replace class = 9 if n96b == 14 ;
label define clabel 9 "Transport Equipment", modify ;

replace class = 9 if n96b == 15 ;
label define clabel 9 "Transport Equipment", modify ;

replace class = 11 if n96b == 16 ;
label define clabel 11 "Electrical and Optical Equipment", modify ;

replace class = 11 if n96b == 17 ;
label define clabel 11 "Electrical and Optical Equipment", modify ;

replace class = 13 if n96b == 6 ;
label define clabel 13 "Wood products", modify ;

replace class = 14 if n96b == 5 ;
label define clabel 14 "Pulp, Paper, PrintPub", modify ;

replace class = 15 if n96b == 4 ;
label define clabel 15 "Textiles, Leather, Footwear", modify ;

replace class = 16 if n96b == 3 ;
label define clabel 16 "Food Beverage", modify ;

sort class ;

drop if class == . ;

sort idnum class ;

save data/6_concordance2006.dta, replace ;
log close;
