* Program file of the project "Outsourcing and Firm Productivity" - 8_IAB_merge00.do
* Contents: merge yr2000 and yr2005 IAB data with HHI, OSS and GFC data
*                               
* Purpose: Create a panel dataset of yr2000 and yr2005 variables.  
*
* Level of Aggregation:  Data from OECD STAN 2006 edition, I-O is industry level data, ISIC rev 3. 'CLASS' concordance available from Authors upon request. 

clear 
set mem 600m

capture log close
log using log/8_IAB_merge00.log, replace


#delimit ;

* Make sure using data is sorted on by variable ;
* 2000 data ;

use data/5_concordance2001;
sort class;

* Add OSS Data ;
merge class using orig/OSS_results_2000 ;
keep if _merge == 3 ;
drop _merge;
sort class;

* Add HHI Data ;

merge class using data/7_HHImajor ;
keep if _merge == 3 ; 
drop _merge;
sort class;

merge class using data/7_HHIminor ;
keep if _merge == 3 ;
drop _merge;
sort class;

drop HHI_Major95 HHI_Major05 HHI_Minor95 HHI_Minor05 ;

save data/8_IAB_merge00.dta, replace ;
log close;
