* Program file of the project "Outsourcing and Firm Productivity" - 9_IAB_merge05.do
* Contents: merge yr2000 and yr2005 IAB data with HHI, OSS and GFC data
*                               
* Purpose: Create a panel dataset of yr2000 and yr2005 variables.  
*
* Level of Aggregation:  Data from OECD STAN 2006 edition, I-O is industry level data, ISIC rev 3. 'CLASS' concordance available from Authors upon request. 

clear 
set mem 600m

capture log close
log using log/9_IAB_merge05.log, replace


#delimit ;

* Make sure using data is sorted on by variable ;
* 2005 data ;

use data/6_concordance2006;
sort class;

* Add OSS Data ;
merge class using orig/OSS_results_2005 ;
keep if _merge == 3 ;
drop _merge;
sort class;

* Add HHI Data ;

merge class using data/7_HHImajor ;
keep if _merge == 3 ; 
drop _merge;
sort class;

merge class using data/7_HHIminor ;
keep if _merge == 3 ;
drop _merge;
sort class;

drop  HHI_Major95 HHI_Major00 HHI_Minor95 HHI_Minor00;

save data/9_IAB_merge05.dta, replace ;
log close;
