* Program file of the project "Outsourcing and Firm Productivity" - 26A_qreg_00.do
* Contents: Perform quantile regression analysis for relevant specifications - estimated at median 
* Program file created by Sumon at IAB

* Level of Aggregation:  Firm level IAB data, industry classification according to the variable class

clear 
set mem 600m

capture log close
log using log/26A_qreg_00.log, replace

#delimit ;

use data/11_FrontierPrep.dta ; 

global industry "d4 d5 d6 d8 d9 d11 d15 d16" ;


******************************************************** ;
* (i) Regression with tl_prod00 as the LHS variable      ;
******************************************************** ;

display as text "                                   " ;
display as text "  Year 2000                        " ;
display as text "                                   " ;
display as text "The Model being summarized         " ;
display as text " is using total employment         " ;
display as text "                                   " ;
display as text "                                   " ;

* FH measure of Outsourcing ;

qreg tl_prod00 HHI_Major00 FH_OSS_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod00 HHI_Minor00 FH_OSS_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tl_prod00 HHI_Major00 FH_OSS_narrow_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod00 HHI_Minor00 FH_OSS_narrow_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;

* Direct measure of Outsourcing ;

qreg tl_prod00 HHI_Major00 OSS_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod00 HHI_Minor00 OSS_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tl_prod00 HHI_Major00 OSS_narrow_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod00 HHI_Minor00 OSS_narrow_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 

************************************************************ ;
* (ii) Regression with tprofit_per_emp00 as the LHS variable  ;
************************************************************ ;

* FH measure of Outsourcing ;

qreg tprofit_per_emp00 HHI_Major00 FH_OSS_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp00 HHI_Minor00 FH_OSS_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tprofit_per_emp00 HHI_Major00 FH_OSS_narrow_2000 FH_OSS_output00 lnoutput00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp00 HHI_Minor00 FH_OSS_narrow_2000 FH_OSS_output00 lnoutput00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;

* Direct measure of Outsourcing ;

qreg tprofit_per_emp00 HHI_Major00 OSS_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp00 HHI_Minor00 OSS_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tprofit_per_emp00 HHI_Major00 OSS_narrow_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp00 HHI_Minor00 OSS_narrow_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;


*************************************************************** ;
* (iii) Regression with profit_per_sales00 as the LHS variable  ;
*************************************************************** ;

* FH measure of Outsourcing ;

qreg profit_per_sales00 HHI_Major00 FH_OSS_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales00 HHI_Minor00 FH_OSS_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg profit_per_sales00 HHI_Major00 FH_OSS_narrow_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales00 HHI_Minor00 FH_OSS_narrow_2000 lnoutput00 FH_OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;

* Direct measure of Outsourcing ;

qreg profit_per_sales00 HHI_Major00 OSS_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales00 HHI_Minor00 OSS_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg profit_per_sales00 HHI_Major00 OSS_narrow_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales00 HHI_Minor00 OSS_narrow_2000 lnoutput00 OSS_output00 agenew2000 qualcapnew00 skill_labour00 eastgerman00 foreign00 public00 other00 workcouncnew00 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 



log close ;
