* Program file of the project "Outsourcing and Firm Productivity" - 27A_qreg_05.do
* Contents: Perform quantile regression analysis for relevant specifications - estimated at median 
* Program file created by Sumon at IAB

* Level of Aggregation:  Firm level IAB data, industry classification according to the variable class

clear 
set mem 600m

capture log close
log using log/27A_qreg_05.log, replace

#delimit ;

use data/11_FrontierPrep.dta ; 

global industry "d4 d5 d6 d8 d9 d11 d15 d16" ;


******************************************************** ;
* (i) Regression with tl_prod05 as the LHS variable      ;
******************************************************** ;

display as text "                                   " ;
display as text "  Year 2000                        " ;
display as text "                                   " ;
display as text "The Model being summarized         " ;
display as text " is using total employment         " ;
display as text "                                   " ;
display as text "                                   " ;

* FH measure of Outsourcing ;

qreg tl_prod05 HHI_Major05 FH_OSS_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod05 HHI_Minor05 FH_OSS_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tl_prod05 HHI_Major05 FH_OSS_narrow_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod05 HHI_Minor05 FH_OSS_narrow_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;

* Direct measure of Outsourcing ;

qreg tl_prod05 HHI_Major05 OSS_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod05 HHI_Minor05 OSS_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tl_prod05 HHI_Major05 OSS_narrow_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tl_prod05 HHI_Minor05 OSS_narrow_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;


************************************************************ ;
* (ii) Regression with profit_per_emp05 as the LHS variable  ;
************************************************************ ;

display as text "                                   " ;
display as text "  Year 2000                        " ;
display as text "                                   " ;
display as text "The Model being summarized         " ;
display as text " is using total employment         " ;
display as text "                                   " ;
display as text "                                   " ;

* FH measure of Outsourcing ;

qreg tprofit_per_emp05 HHI_Major05 FH_OSS_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp05 HHI_Minor05 FH_OSS_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tprofit_per_emp05 HHI_Major05 FH_OSS_narrow_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp05 HHI_Minor05 FH_OSS_narrow_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;

* Direct measure of Outsourcing ;

qreg tprofit_per_emp05 HHI_Major05 OSS_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp05 HHI_Minor05 OSS_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg tprofit_per_emp05 HHI_Major05 OSS_narrow_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg tprofit_per_emp05 HHI_Minor05 OSS_narrow_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 


*************************************************************** ;
* (iii) Regression with profit_per_sales05 as the LHS variable  ;
*************************************************************** ;

* FH measure of Outsourcing ;

qreg profit_per_sales05 HHI_Major05 FH_OSS_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales05 HHI_Minor05 FH_OSS_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg profit_per_sales05 HHI_Major05 FH_OSS_narrow_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales05 HHI_Minor05 FH_OSS_narrow_2005 lnoutput05 FH_OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;

* Direct measure of Outsourcing ;

qreg profit_per_sales05 HHI_Major05 OSS_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales05 HHI_Minor05 OSS_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 
qreg profit_per_sales05 HHI_Major05 OSS_narrow_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ;
qreg profit_per_sales05 HHI_Minor05 OSS_narrow_2005 lnoutput05 OSS_output05 agenew2005 qualcapnew05 skill_labour05 eastgerman05 foreign05 public05 other05 workcouncnew05 $industry, quantile(0.5) nolog iter(16000) wlsiter(100) ; 

log close;
