* Program file of the project "Outsourcing and Firm Productivity" - 34_IVregonelag00.do
* Contents: Perform IV regression analysis for relevant specifications  
*           Check for Robustness of Total Employee Measure

* Level of Aggregation:  Firm level IAB data, industry classification according to the variable class

clear 
set mem 600m
set more off

capture log close

#delimit ;

use data/11_FrontierPrep.dta ; 

local depvar "tprofit_per_emp profit_per_sales ln_tlprod";

foreach x of local depvar {;

log using log/34_IVregonelag_`x'00.log, replace;


display as text "  NO AGE VARIABLE                 ";



display as text "            "; 
display as text "OSS broad IV"; 
display as text "            ";   
ivreg2 `x'00 OSS_2000 HHI_Minor00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 OSS_2000 HHI_Minor00 OSS_output00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV";
display as text "            "; 
ivreg2 `x'00 OSS_narrow_2000 HHI_Minor00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 OSS_narrow_2000 HHI_Minor00 OSS_output00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV";
display as text "            ";    
ivreg2 `x'00 FH_OSS_2000 HHI_Minor00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 FH_OSS_2000 HHI_Minor00 FH_OSS_output00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV";
display as text "            "; 
ivreg2 `x'00 FH_OSS_narrow_2000 HHI_Minor00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 FH_OSS_narrow_2000 HHI_Minor00 FH_OSS_output00 agenew2000 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 =  class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;


display as text "  NOW USING DUMMY AGE VARIABLES - 0 Before or on 1990, 1 after ";

display as text "            "; 
display as text "OSS broad IV"; 
display as text "            ";   
ivreg2 `x'00 OSS_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 OSS_2000 HHI_Minor00 OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV";
display as text "            "; 
ivreg2 `x'00 OSS_narrow_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 OSS_narrow_2000 HHI_Minor00 OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV";
display as text "            ";    
ivreg2 `x'00 FH_OSS_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 FH_OSS_2000 HHI_Minor00 FH_OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV";
display as text "            "; 
ivreg2 `x'00 FH_OSS_narrow_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 FH_OSS_narrow_2000 HHI_Minor00 FH_OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = agenew2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;


display as text "  NOW USING CONTINUOUS AGE VARIABLES - LEFT CENSORED ";

display as text "            "; 
display as text "OSS broad IV"; 
display as text "            ";   
ivreg2 `x'00 OSS_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 OSS_2000 HHI_Minor00 OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV";
display as text "            "; 
ivreg2 `x'00 OSS_narrow_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 OSS_narrow_2000 HHI_Minor00 OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV";
display as text "            ";    
ivreg2 `x'00 FH_OSS_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 FH_OSS_2000 HHI_Minor00 FH_OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV";
display as text "            "; 
ivreg2 `x'00 FH_OSS_narrow_2000 HHI_Minor00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'00 FH_OSS_narrow_2000 HHI_Minor00 FH_OSS_output00 eastgerman00 foreign00 public00 other00 workcouncnew00 (qualcapnew00 skill_labour00 lnoutput00 = age2000 class  lnoutput99  skill_labour99  qualcapnew99 ), first;
overid;


log close;
};

