* Program file of the project "Outsourcing and Firm Productivity" - 35_IVregonelag05.do
* Contents: Perform IV regression analysis for relevant specifications  
*           Check for Robustness of Total Employee Measure

* Level of Aggregation:  Firm level IAB data, industry classification according to the variable class

clear 
set mem 605m
set more off

capture log close

#delimit ;

use data/11_FrontierPrep.dta ; 

local depvar "tprofit_per_emp profit_per_sales ln_tlprod";

foreach x of local depvar {;

log using log/35_IVregonelag_`x'05.log, replace;

display as text "            ";   
display as text "OSS broad IV";   
display as text "            ";   
ivreg2 `x'05 OSS_2005 HHI_Minor05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 OSS_2005 HHI_Minor05 OSS_output05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV";
display as text "            "; 
ivreg2 `x'05 OSS_narrow_2005 HHI_Minor05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV plus oss_output interaction"; 
display as text "            "; 
ivreg2 `x'05 OSS_narrow_2005 HHI_Minor05 OSS_output05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV";
display as text "            ";    
ivreg2 `x'05 FH_OSS_2005 HHI_Minor05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 FH_OSS_2005 HHI_Minor05 FH_OSS_output05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV";
display as text "            "; 
ivreg2 `x'05 FH_OSS_narrow_2005 HHI_Minor05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 FH_OSS_narrow_2005 HHI_Minor05 FH_OSS_output05 agenew2005 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 =  class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "  NOW USING DUMMY AGE VARIABLE, 0 for 1990 or before, 1 after ";


display as text "            ";   
display as text "OSS broad IV";   
display as text "            ";   
ivreg2 `x'05 OSS_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 OSS_2005 HHI_Minor05 OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV";
display as text "            "; 
ivreg2 `x'05 OSS_narrow_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV plus oss_output interaction"; 
display as text "            "; 
ivreg2 `x'05 OSS_narrow_2005 HHI_Minor05 OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV";
display as text "            ";    
ivreg2 `x'05 FH_OSS_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 FH_OSS_2005 HHI_Minor05 FH_OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV";
display as text "            "; 
ivreg2 `x'05 FH_OSS_narrow_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 FH_OSS_narrow_2005 HHI_Minor05 FH_OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = agenew2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text " NOW USING CONTINUOUS AGE VARIABLE - LEFT CENSORED ";


display as text "            ";   
display as text "OSS broad IV";   
display as text "            ";   
ivreg2 `x'05 OSS_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04  qualcapnew03  ), first;
overid;

display as text "            "; 
display as text "OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 OSS_2005 HHI_Minor05 OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV";
display as text "            "; 
ivreg2 `x'05 OSS_narrow_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "OSS narrow IV plus oss_output interaction"; 
display as text "            "; 
ivreg2 `x'05 OSS_narrow_2005 HHI_Minor05 OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV";
display as text "            ";    
ivreg2 `x'05 FH_OSS_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04 skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS broad IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 FH_OSS_2005 HHI_Minor05 FH_OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV";
display as text "            "; 
ivreg2 `x'05 FH_OSS_narrow_2005 HHI_Minor05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;

display as text "            "; 
display as text "FH OSS narrow IV plus oss_output interaction";
display as text "            ";  
ivreg2 `x'05 FH_OSS_narrow_2005 HHI_Minor05 FH_OSS_output05 eastgerman05 foreign05 public05 workcouncnew05 (qualcapnew05 skill_labour05 lnoutput05 = age2005 class  lnoutput04  skill_labour04  qualcapnew03 ), first;
overid;




log close;
};

