clear
set more off
capture log close
log using narrow_import.log, replace

foreach y of global YEAR {

use import`y', clear

drop if isicn == .

*** Stata needs a nxn matrix to perform the following functions

mkmat i1-i48, matrix(X)

*** This makes a square matrix of variables i1 thru i48.  Note i1 corresponds to ISIC industry 1

matrix I = vecdiag(X)

*** matrix I is the 1 x n matrix of the diagonal entries of matrix X
*** The diagonal entries represent the import of good i into industry i

matrix IMPORT = I'

*** transpose I to get a n x 1 matrix

svmat IMPORT, name(narrow_import)

*** creates the variable 'narrow_import' from matrix IMPORT

keep isicn industry narrow_import

save narrow_import`y', replace
}

log close
exit
