** Program file created by Craig Aubuchon during 2008-09
** Uses OECD Structural Analysis (STAN) 2006 I-O Matrices, ISIC Rev 3, available from <sti.contact@oecd.org>
** Calculate measures of outsourcing intensity following Feenstra and Hanson (1999), Geischecker and Gorg (2008),
** and OECD De Backer and Yamano (2008) working paper.
** The following program files calculate OSS measures for the full 48 industries; the same methodology is applied
** to the files using an aggregated measure (in the manufacturing sector), developed for use with the IAB data from 
** the FDZ.

clear
capture log close
log using log/master.log, replace
set more off
cd "D:\work\Subhayu\OECD Data\OSS Measure"
adopath + prog

global YEAR "1995 2000 2005"

* Import Data
do prog/getdata

* Merge Data
do prog/merge_data

* Calculate non energy imports, total intermediate imports and OECD(2008), GG(2008) measures of OSS
do "prog/OSS calculation"

** Calculate the FH(1999) measures in the following three do files (split apart for readability):
* Create a measure of import intensity from final goods
do "prog/final goods impint"

* Calculate a measure of importance of each import to total process (a weight)
do prog/weight

* Perform Calculation (roughly, sum of (impint * weight) for each industry
do "prog/FH OSS calculation"

* Output and summarize data 
do prog/output

log close
exit



*** Old Do files
*do total_purchase
*do impint
*do OSS
*do test