******************************************************************
** Compare Impint (imports / consumption) from the FH measure   **
** to the ratio of intermediate imports to                      ** 
**  intermediate domestic consumption                           **
** Note that the FH measure underestimates the importance of    **
** the intermediate imports.                                    **
** See Appendix of Daveri and Jona-Lasinio (2008)               **
******************************************************************

clear
set more off
capture log close
log using "log/FH comparison.log", replace

set more off

foreach y of global YEAR {

use data/master`y', clear

egen int_imports = rowtotal(i1-i48)

egen int_domestic = rowtotal(d1-d48)

generate int_impint = int_imports / int_domestic

summarize impint int_impint

list isicn impint int_impint

generate impint_ratio_check_`y' = impint/int_impint

save data/master`y', replace

}

log close
exit
