clear
capture log close
log using "log/final goods impint.log", replace

set more off

foreach y of global YEAR {

use data/master`y', clear

***************************************************************
** Generate the measure of IMPINT used by both F&H and A&W   **
** Note, they use IMF balance of payments trade data to      **
** calculate this statistic, and it is used as an estimate   **
** to help calculate intermediate imports                    **
** Using the I-O tables, we already have intermediate imports**
** and so this is redundant.  Imports and Production come    **
** from the total tab of the I-O table, and are the sum of   **
** the rows in for each industry.  Note, these totals do not **
** exclude any energy intensive industries.                  **
***************************************************************

generate impint = imports / production

save data/master`y', replace
}

log close
exit
