clear
set more off
capture log close
log using log/weight.log, replace

foreach y of global YEAR {

use data/master`y', clear

*******************************************************************
** This loop calculates the weight of each input into the total  **
** purchase by the industry.                                     **
** w(i) = purchase of input j by industry i divided by total     **
**   purchase of all non energy inputs by industry i.            **
** In this set up, observation [_n] would be input j.  That is,  ** 
** each observation by variable is the input j.  This is due to  ** 
** the square matrix of the input output table.                  **
*******************************************************************

mkmat t1-t48, matrix(T)

mkmat total_purchase, matrix(TT)

matrix w = J(48,48,0)

forvalues i = 1(1)48 {
  forvalues k = 1(1)48 {
    matrix w[`k',`i'] = T[`k',`i'] / TT[`i',1]
   }
  }

save data/master`y', replace
}

log close
exit